<?php
/**
 * MyBB 1.4 English Language Pack
 * Copyright © 2008 MyBB Group, All Rights Reserved
 * 
 * $Id: helpdocs.lang.php 5379 2011-02-21 11:06:42Z Tomm $
 */

// Help Document 1
$l['d1_name'] = "User Registration";
$l['d1_desc'] = "Perks and privileges to user registration.";
$l['d1_document'] = "Some parts of this forum may require you to be logged in and registered. Registration is free and takes a few minutes to complete.
<br /><br />You are encouraged to register; once you register you will be able to post messages, set your own preferences, and maintain a profile.
<br /><br />Some of the features that generally require registration are subscriptions, changing of styles, accessing of your Personal Pad (simple notepad) and emailing forum members.";

// Help Document 2
$l['d2_name'] = "Updating Profile";
$l['d2_desc'] = "Changing your data currently on record.";
$l['d2_document'] = "At some point during your stay, you may decide you need to update some information such as your instant messenger information, your password, or perhaps you need to change your email address. You may change any of this information from your user control panel. To access this control panel, simply click on the link in the upper right hand corner of most any page entitled \"user cp\". From there, simply choose \"Edit Profile\" and change or update any desired items, then proceed to click the submit button located at the bottom of the page for changes to take effect.";

// Help Document 3
$l['d3_name'] = "Use of Cookies on MyBB";
$l['d3_desc'] = "MyBB uses cookies to store certain information about your registration.";
$l['d3_document'] = "MyBB makes use of cookies to store your login information if you are registered, and your last visit if you are not.
<br /><br />Cookies are small text documents stored on your computer; the cookies set by this forum can only be used on this website and pose no security risk.
<br /><br />Cookies on this forum also track the specific topics you have read and when you last read them.
<br /><br />To clear all cookies set by this forum, you can click <a href=\"misc.php?action=clearcookies&amp;key={1}\">here</a>.";

// Help Document 4
$l['d4_name'] = "Logging In and Out";
$l['d4_desc'] = "How to login and log out.";
$l['d4_document'] = "When you login, you set a cookie on your machine so that you can browse the forums without having to enter in your username and password each time. Logging out clears that cookie to ensure nobody else can browse the forum as you.
<br /><br />To login, simply click the login link at the top right hand corner of the forum. To log out, click the log out link in the same place. In the event you cannot log out, clearing cookies on your machine will take the same effect.";

// Help Document 5
$l['d5_name'] = "Posting a New Topic";
$l['d5_desc'] = "Starting a new thread in a forum.";
$l['d5_document'] = "When you go to a forum you are interested in and you wish to create a new topic (or thread), simply choose the button at the top and bottom of the forums entitled \"New topic\". Please take note that you may not have permission to post a new topic in every forum as your administrator may have restricted posting in that forum to staff or archived the forum entirely.";

// Help Document 6
$l['d6_name'] = "Posting a Reply";
$l['d6_desc'] = "Replying to a topic within a forum.";
$l['d6_document'] = "During the course of your visit, you may encounter a thread to which you would like to make a reply. To do so, simply click the \"Post reply\" button at the bottom or top of the thread. Please take note that your administrator may have restricted posting to certain individuals in that particular forum.
<br /><br />Additionally, a moderator of a forum may have closed a thread meaning that users cannot reply to it. There is no way for a user to open such a thread without the help of a moderator or administrator.";

// Help Document 7
$l['d7_name'] = "MyCode";
$l['d7_desc'] = "Learn how to use MyCode to enhance your posts.";
$l['d7_document'] = "You can use MyCode, a simplified version of HTML, in your posts to create certain effects.
<p><br />[b]This text is bold[/b]<br />&nbsp;&nbsp;&nbsp;<b>This text is bold</b>
<p>[i]This text is italicized[/i]<br />&nbsp;&nbsp;&nbsp;<i>This text is italicized</i>
<p>[u]This text is underlined[/u]<br />&nbsp;&nbsp;&nbsp;<u>This text is underlined</u>
<p>[s]This text is striked out[/s]<br />&nbsp;&nbsp;&nbsp;<strike>This text is striked out</strike>
<p><br />[url]http://www.example.com/[/url]<br />&nbsp;&nbsp;&nbsp;<a href=\"http://www.example.com/\">http://www.example.com/</a>
<p>[url=http://www.example.com/]Example.com[/url]<br />&nbsp;&nbsp;&nbsp;<a href=\"http://www.example.com/\">Example.com</a>
<p>[email]example@example.com[/email]<br />&nbsp;&nbsp;&nbsp;<a href=\"mailto:example@example.com\">example@example.com</a>
<p>[email=example@example.com]E-mail Me![/email]<br />&nbsp;&nbsp;&nbsp;<a href=\"mailto:example@example.com\">E-mail Me!</a>
<p>[email=example@example.com?subject=spam]E-mail with subject[/email]<br />&nbsp;&nbsp;&nbsp;<a href=\"mailto:example@example.com?subject=spam\">E-mail with subject</a>
<p><br />[quote]Quoted text will be here[/quote]<br />&nbsp;&nbsp;&nbsp;<quote>Quoted text will be here</quote>
<p>[code]Text with preserved formatting[/code]<br />&nbsp;&nbsp;&nbsp;<code>Text with preserved formatting</code>
<p><br />[img]http://www.php.net/images/php.gif[/img]<br />&nbsp;&nbsp;&nbsp;<img src=\"http://www.php.net/images/php.gif\">
<p>[img=50x50]http://www.php.net/images/php.gif[/img]<br />&nbsp;&nbsp;&nbsp;<img src=\"http://www.php.net/images/php.gif\" width=\"50\" height=\"50\">
<p><br />[color=red]This text is red[/color]<br />&nbsp;&nbsp;&nbsp;<font color=\"red\">This text is red</font>
<p>[size=3]This text is size 3[/size]<br />&nbsp;&nbsp;&nbsp;<font size=\"3\">This text is size 3</font>
<p>[font=Tahoma]This font is Tahoma[/font]<br />&nbsp;&nbsp;&nbsp;<font face=\"Tahoma\">This font is Tahoma</font>
<p><br />[align=center]This is centered[/align]<div align=\"center\">This is centered</div>
<p>[align=right]This is right-aligned[/align]<div align=\"right\">This is right-aligned</div>
<p><br />[list]<br />[*]List Item #1<br />[*]List Item #2<br />[*]List Item #3<br />[/list]<br /><ul><li>List item #1</li><li>List item #2</li><li>List Item #3</li>
</ul>
<p>You can make an ordered list by using [list=1] for a numbered, and [list=a] for an alphabetical list.</p>";
?>